function J2P_tj = kin_xyzbc_tt_J2P_tj(in1,in2,in3,in4)
%kin_xyzbc_tt_J2P_tj
%    J2P_tj = kin_xyzbc_tt_J2P_tj(IN1,IN2,IN3,IN4)

%    This function was generated by the Symbolic Math Toolbox version 9.1.
%    07-Nov-2023 14:54:38

%Jacobian second derivative ( Forward Kinematics ) : 
%INPUTS : 
%	r_j    (5x1) : pose vector( joint space )
%	v_j    (5x1) : speed vector( joint space )
%	a_j    (5x1) : acceleration vector( joint space )
%	j_j    (5x1) : jerk vector( joint space )
%	p      (3x5) : parameters
%OUTPUTS : 
%	M      (5x5) : resulting matrix
%#codegen
b = in1(4,:);
c = in1(5,:);
jp1 = in2(1,:);
jp2 = in2(2,:);
jp3 = in2(3,:);
jp4 = in2(4,:);
jp5 = in2(5,:);
jpp1 = in3(1,:);
jpp2 = in3(2,:);
jpp3 = in3(3,:);
jpp4 = in3(4,:);
jpp5 = in3(5,:);
offB1 = in4(10);
offB2 = in4(11);
offC1 = in4(13);
offB3 = in4(12);
offC2 = in4(14);
offC3 = in4(15);
offM1 = in4(1);
offM2 = in4(2);
offM3 = in4(3);
offT1 = in4(4);
offT2 = in4(5);
offT3 = in4(6);
x = in1(1,:);
y = in1(2,:);
z = in1(3,:);
t2 = cos(b);
t3 = cos(c);
t4 = sin(b);
t5 = sin(c);
t6 = jp4.^2;
t7 = jp5.^2;
t12 = -offM1;
t13 = -offM2;
t14 = -offM3;
t8 = offB1.*t3;
t9 = offB2.*t3;
t10 = offB1.*t5;
t11 = offB2.*t5;
t15 = jp1.*t2.*t3;
t16 = jp3.*t2.*t3;
t17 = jp4.*t2.*t3;
t18 = jp5.*t2.*t3;
t19 = jp1.*t2.*t5;
t20 = jp1.*t3.*t4;
t21 = jp3.*t2.*t5;
t22 = jp3.*t3.*t4;
t23 = jp4.*t2.*t5;
t24 = jp4.*t3.*t4;
t25 = jp5.*t2.*t5;
t26 = jp5.*t3.*t4;
t27 = jp1.*t4.*t5;
t28 = jp3.*t4.*t5;
t29 = jp4.*t4.*t5;
t30 = jp5.*t4.*t5;
t36 = offB1+offC1+offT1+t12+x;
t37 = offB2+offC2+offT2+t13+y;
t38 = offB3+offC3+offT3+t14+z;
t31 = -t9;
t32 = -t19;
t33 = -t22;
t34 = -t29;
t35 = -t30;
t39 = t3.*t37;
t40 = t5.*t37;
t41 = t23+t26;
t42 = t24+t25;
t43 = t4.*t5.*t38;
t45 = t2.*t3.*t36;
t46 = t2.*t3.*t38;
t47 = t2.*t5.*t36;
t48 = t3.*t4.*t36;
t49 = t2.*t5.*t38;
t50 = t3.*t4.*t38;
t51 = t4.*t5.*t36;
t44 = -t40;
t52 = t17+t35;
t53 = t18+t34;
t54 = -t45;
t55 = -t47;
t56 = -t50;
t57 = t46+t48;
t58 = t49+t51;
t59 = jp4.*t58;
t60 = jp5.*t58;
t61 = t45+t56;
t62 = t43+t55;
t63 = jp4.*t57;
t64 = jp5.*t57;
t70 = t8+t11+t44+t50+t54;
t65 = jp4.*t62;
t66 = -t60;
t67 = jp4.*t61;
t68 = -t63;
t71 = t10+t31+t39+t62;
t69 = -t65;
t72 = t16+t20+t66+t67;
t73 = t21+t27+t64+t69;
mt1 = [jp5.*t29.*2.0-jpp4.*t3.*t4-jpp5.*t2.*t5-t2.*t3.*t6-t2.*t3.*t7,jp5.*t24.*2.0-jpp5.*t2.*t3+jpp4.*t4.*t5+t2.*t5.*t6+t2.*t5.*t7,jpp4.*t2-t4.*t6,0.0,0.0,jpp5.*t3-t5.*t7,-jpp5.*t5-t3.*t7,0.0,0.0,0.0,jp5.*t23.*2.0-jpp4.*t2.*t3+jpp5.*t4.*t5+t3.*t4.*t6+t3.*t4.*t7,jp5.*t17.*2.0+jpp4.*t2.*t5+jpp5.*t3.*t4-t4.*t5.*t6-t4.*t5.*t7,-jpp4.*t4-t2.*t6,0.0,0.0,-jp4.*(t15-t22+t68+jp5.*t62)+jp3.*t42-jp1.*t52+jp5.*t73+jpp5.*t58-jpp4.*t61-jpp1.*t3.*t4-jpp3.*t2.*t3];
mt2 = [jp1.*t41+jp3.*t53+jp5.*t72+jpp5.*t57-jpp4.*t62+jp4.*(t19-t28-t59+jp5.*t61)+jpp1.*t4.*t5+jpp3.*t2.*t5,jpp1.*t2-jpp3.*t4-jp4.*(jp1.*t4+jp3.*t2+jp4.*(t2.*t36-t4.*t38))-jpp4.*(t2.*t38+t4.*t36)-jp1.*jp4.*t4-jp3.*jp4.*t2,0.0,0.0,-jp5.*(t15+t33+t68+jp2.*t5+jp5.*t71)+jp3.*t41-jp1.*t53+jp4.*t73+jpp2.*t3+jpp4.*t58+jpp5.*t70-jp2.*jp5.*t5-jpp1.*t2.*t5+jpp3.*t4.*t5];
mt3 = [-jp5.*(t28+t32+t59+jp2.*t3+jp5.*t70)+jp1.*t42+jp3.*t52+jp4.*t72-jpp2.*t5+jpp4.*t57-jpp5.*t71-jp2.*jp5.*t3-jpp1.*t2.*t3+jpp3.*t3.*t4,0.0,0.0,0.0];
J2P_tj = reshape([mt1,mt2,mt3],5,5);
